%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                  %
%    DAEdalon Finite-Element-Project                               %
%                                                                  %
%    Copyright 2003 Amin Mozaffarin                                %
%    Contact: http://www.daedalon.org                              %
%                                                                  %
%                                                                  %
%    This file is part of DAEdalon.                                %
%                                                                  %
%    DAEdalon is free software; you can redistribute it            %
%    and/or modify it under the terms of the GNU General           %
%    Public License as published by the Free Software Foundation;  %
%    either version 2 of the License, or (at your option)          %
%    any later version.                                            %
%                                                                  %
%    DAEdalon is distributed in the hope that it will be           %
%    useful, but WITHOUT ANY WARRANTY; without even the            %
%    implied warranty of MERCHANTABILITY or FITNESS FOR A          %
%    PARTICULAR PURPOSE.  See the GNU General Public License       %
%    for more details.                                             %
%                                                                  %
%    You should have received a copy of the GNU General            %
%    Public License along with Foobar; if not, write to the        %
%    Free Software Foundation, Inc., 59 Temple Place, Suite 330,   %
%    Boston, MA  02111-1307  USA                                   %
%                                                                  %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function gui_setup

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% globale GUIVariablen
global fid_dae;

% Matlab Versionsnummer
vers_nr = sscanf(version,'%f');

% Infos ausgeben und Logo im Grafikfenster plotten

% Aktuelle Versionsnummer
versnum = 2.00;

disp(sprintf('\nDAEdalon Finite-Element-Project'))
disp(sprintf('Version: %3.2f',versnum))
disp(sprintf(['This Project is placed under the GNU General ', ...
	      'Public License\n(for Details read file COPYING.TXT).']))
disp(sprintf('Kontakt: http://www.daedalon.org'))
disp(sprintf('Verwendete MATLAB-Version: %1.1f',vers_nr(1)))

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Logo anzeigen
if findobj('Name','DAEControl')
    return
end

if findobj('Name','DAEdalon')
    delete(fid_dae)
end

fid_dae = figure;
clf reset;
set(fid_dae,'Number','off','Name','DAEdalon','CloseRequestFcn','crf')

logo = imread('logo_bunt_kl.jpg','jpg');
image(logo);
axis image;

set(gca,'XTick',[])
set(gca,'YTick',[])
text(20,620,['Version ',num2str(versnum)],'fontsize',16,'color','b')
xlabel('www.DAEdalon.org','fontsize',16)
% Ende dae.m


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Aminem
% Menu zum Starten/Ausschalten der GUI
dae_menu = uimenu(fid_dae,'Label','&DAEControl');

% Untermenu
global gui_start;
gui_start = uimenu(dae_menu,'Label','&Start GUI','Enable','off','Callback','DAEGui_dummy');

global gui_close;
gui_close = uimenu(dae_menu,'Label','&Close GUI','Callback','CB_GUI_close');

% Help Menu
dae_web   = uimenu(fid_dae,'Label','DAE&Online','Callback','dae_link');

% GUI aufrufen
z = dlmread('./gui/gui_check.txt');

if z == 1
    DAEGui_dummy
else
    set(gui_start,'Enable','on')
    set(gui_close,'Enable','off')
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%